#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "midifile.h"

#define CHANNEL 1
#define PROGRAM 10
#define REVERB 6
int TICKSPEREIGHTH=24;

/* PITCH stuff */
#define TON(i) (48+i)
#define VEL(i) 100
#define PITCH_TYPE char
#include "mypitch.h"

void init()
{
  const unsigned char program=PROGRAM;
  mf_w_midi_event(0,program_chng,CHANNEL,&program,1);
  mf_w_tempo(0,400000);
  PITCH_INIT;
}

FILE *infile;
int writetrack(int number)
{
  long i,time=0,velocity=100;

  init();

#define NOTEOFF(i) \
  (mf_w_midi_event(time,note_off,CHANNEL,&(pitch[2*(i)]),2),time=0)
#define NOTEON(i) \
  (mf_w_midi_event(time,note_on,CHANNEL,&(pitch[2*(i)]),2),time=0)
#define WAIT time+=TICKSPEREIGHTH/2
#include "my.h"

    mf_w_meta_event(0,end_of_track,0,0);
  return(0);
}

FILE *ofile;

int OutputC(unsigned char c)
{
  return fputc(c,ofile);
}

int nullfunc(int c)
{
  mf_w_meta_event(0,end_of_track,0,0);
  return 1;
}

int main(int argc,char **argv)
{
  unsigned char buf1[5],buf2[5];
  if((argc>1)&&strcmp(argv[1],"-"))
    infile=fopen(argv[1],"r"); else infile=stdin;
  Mf_putc=OutputC;
  Mf_wtrack=writetrack;
  Mf_wtempotrack=nullfunc;
  if((argc>2)&&strcmp(argv[2],"-"))
    ofile=fopen(argv[2],"w"); else ofile=stdout;
  setbuffer(infile,buf1,0);
  if(argc>3) TICKSPEREIGHTH=atoi(argv[3]);

  if((infile!=NULL)&&(ofile!=NULL))
    mfwrite((ofile==stdout)?0:1,2,48,ofile);

  fclose(infile); fclose(ofile);
}

